#!/usr/bin/perl

###############################################################################
#                                                                             #
# Filename: memory.pl                                                         #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Calculate free memory

    # open(FILE, "/proc/meminfo") or "Can't open file.txt: $!";
    # read FILE, $meminfo, -s FILE;
    # close FILE;

    $_   = `/usr/bin/procinfo -b`; 

    my $actual_memory = $1 if /Mem:\s*(\w+)/g;
    my $used_memory = $1 if /(\w+)/g;
    my $free_memory = $1 if /(\w+)/g;

    my $shared_memory = $1 if /(\w+)/g;
    my $buffered_memory = $1 if /(\w+)/g;
    my $cached_memory = $1 if /(\w+)/g;

# Recalculate $use_memory
    $used_memory  = ($used_memory - $buffered_memory - $cached_memory) * 1024;

    my $swap_memory = $1 if /Swap:\s*(\w+)/g;
    my $swap_used = $1 * 1024 if /(\w+)/g;
    my $swap_free = $1 if /(\w+)/g;
     
    
    print "$used_memory\n";
    print "$swap_used\n";

    print "0\n";
    print "\n";
