#!/usr/bin/perl	-w

###############################################################################
#                                                                             #
# Filename: go_index.cgi                                                      #
#                                                                             #
# Description: Contains CGI script needed to render the main group operations #
#              frame.                                                         #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use LanguageResource;
use CGI;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)				= @_;
    my $html;
	my $PreferredLanguage	= (split(/,/, $ENV{'HTTP_ACCEPT_LANGUAGE'}))[0];
	my $StringResource		= new LanguageResource($PreferredLanguage, '/usr/ins/intel/gui/locale', [ 'common-em.lrc' ]);
	my $ErrorMessage		= $StringResource->_S('NO_FRAMES');
	my $Title;

	# Get the title bar.
	$Title = $StringResource->_S('TITLE_BAR_GROUP_OPERATIONS');
	
	$html = <<HERE;
<head>
	<title>$Title</title>
</head>
<frameset rows=101,* border=0 framespacing=0 frameborder=0>
	<frame noresize border=0 scrolling=no marginwidth=0 marginheight=0 src=go_title.cgi name=title_frame>
	<frameset cols=139,*>
		<frame noresize border=0 scrolling=no marginwidth=0 marginheight=0 src=go_navbar.cgi name=menu_frame>
		<frame noresize border=0 scrolling=auto marginwidth=30 marginheight=10 src=go_serverlist.cgi name=main_frame leftmargin=30 topmargin=10>
	</frameset>
</frameset>
</html>
HERE

	print($html);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
