#!/usr/bin/perl	-w

###############################################################################
#                                                                             #
# Filename: go_serveradd.cgi                                                  #
#                                                                             #
# Description: Contains CGI script needed to render the group operations      #
#              server add frame.                                              #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use LanguageResource;
use QuickHelp;
use CGI;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)				= @_;
    my $html;
	my $PreferredLanguage	= (split(/,/, $ENV{'HTTP_ACCEPT_LANGUAGE'}))[0];
	my $StringResource		= new LanguageResource($PreferredLanguage, '/usr/ins/intel/gui/locale', [ 'go_serveradd.lrc', 'server_network.lrc' ]);
	my $QuickHelp			= new QuickHelp($PreferredLanguage, 'go_serveradd', 2);
	my %_R					= ( 'IDT:2'					=> '',
								'TITLE_SELECT_SERVERS'	=> '',
								'SERVER_NAME'			=> '',
								'IP_ADDRESS'			=> '',
								'ADD'					=> '',
								'ERR_iSpecial'			=> '',
								'ERR_iIP'				=> '',
								'ERR_iHost'				=> '',
								'ERR_iBasicIP'			=> '',
								'ERR_mEmptyString'		=> '' );
	my $QuickHelpTitle;
	my $QuickHelpContent;

	# Get the string resources.
	$StringResource->GetStrings(\%_R);

	# Get the quick help information...
	if ((defined($QuickHelpTitle	= $QuickHelp->GetTitle())) &&
		(defined($QuickHelpContent	= $QuickHelp->GetContent())) &&
		(length($QuickHelpTitle)) && (length($QuickHelpContent)))
	{
		$QuickHelpContent = <<HERE;
		<td valign=top width=100%></td> 
		<td valign=top width=177>
			<table align=left border=1 width=60% cellspacing=0 cellpadding=3 bordercolor=#808080>
			<tr bgcolor=gray>
				<td bgcolor=#808080><b><font color=#ffffff>$QuickHelpTitle</font></b></td>
			</tr>
			<tr bgcolor=#ffffcc>
				<td width=160 valign=top align=left>
					$QuickHelpContent
					<p><img width=183 src='/images/blank.gif' height=1></p>
				</td>
			</tr>
			</table>
		</td> 
HERE
	}
	else
	{
		# Safe default.
		$QuickHelpContent = '';
	}
	
	$html = <<HERE;
<!doctype html public "-//IETF//DTD HTML//EN">
<html>
	<head>
		<meta name=copyright content="Copyright (c) 2000 - 2001 Intel Corporation, et al.">
		<link rel=stylesheet href=/style/style.css type=text/css>
		<script src=/style/net_val_lib.js language=javascript></script>
	</head>
	<script>	
	var iSpecial			= '$_R{'ERR_iSpecial'}'; 
	var iIP					= '$_R{'ERR_iIP'}';  
	var iHost				= '$_R{'ERR_iHost'}';  
	var iBasicIP			= '$_R{'ERR_iBasicIP'}'; 
	var mEmptyString		= '$_R{'ERR_mEmptyString'}';
	
	function callAdd()
	{
		if (true == checkIP(document.addserver.ip, 'false'))
		{
			if (true == checkSpecialCharsHost(document.addserver.name, 'false'))
			{
				parent.menu_frame.addtoMachineList(document.addserver.name.value, document.addserver.ip.value);
			}
		}
	}
	
	function dorefresh()
	{
		document.location = '/cgi-bin/ema/go_serverlist.cgi';
	}
	</script>
	<body bgcolor=#ffffff topmargin=5 leftmargin=15>
	<table cellspacing=1 width=100%>
	<tr>
		<td align=left colspan=2><b>
			<font face=Arial size=1>&nbsp;<u><a href=/cgi-bin/ema/go_serverlist.cgi>&lt; $_R{'TITLE_SELECT_SERVERS'}</a></u></font></b>
			<p class=clsTitlePage>$_R{'IDT:2'}</p>
		</td>
	</tr> 
	<tr>
		<td valign=top width=80%>
			<form name=addserver method=post enctype=application/x-www-form-urlencoded>
			<table border=0 width=400 bgcolor=#EEEEEE>
			<tr>
				<td>
					<table border=0 width=100%>
					<tr>
						<td width=100% colspan=2>&nbsp;&nbsp;</td>
					</tr>
					<tr>
						<td width=11% align=left><b>$_R{'SERVER_NAME'}</b></td>
						<td width=22% align=left><b>$_R{'IP_ADDRESS'}</b></td>
					</tr>
					<tr>
						<td width=11% align=left><input type=text name=name size=15></td>
						<td width=22% align=left><input type=text name=ip size=15 value='0.0.0.0'></td>
					</tr>
					<tr>
						<td width=100% colspan=2>&nbsp;&nbsp;</td>
					</tr>
					<tr>
						<td width=100% colspan=2 align=right>
						<input type=button class=clsButton value='$_R{'ADD'}' name=B5 onclick="callAdd();"></td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			</form>
		</td> 
$QuickHelpContent
	</tr>
	</table>
	</body>
</html>
HERE

	print($html);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);


