#!/usr/bin/perl	-w

###############################################################################
#                                                                             #
# Filename: go_date.cgi                                                       #
#                                                                             #
# Description: Contains CGI script needed to enable group operations for date #
#              configuration of element nodes.                                #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use CGI;
use Chronos;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)		= @_;
	my $TimeData	= new Chronos();
	my %CurrentTime;
	my $Status		= 1;
	
	SWITCH:
	{
		# Control the service.
		if (defined($cgi->param('control_start')))		{ $Status = $TimeData->ControlNTP(1); last SWITCH; }
		if (defined($cgi->param('control_stop')))		{ $Status = $TimeData->ControlNTP(0); last SWITCH; }
		if (defined($cgi->param('control_restart')))	{ $Status = $TimeData->ControlNTP(2); last SWITCH; }
	}
	
	# Check to see if anything needs to be applied...
	if ($cgi->param('applya')) 
	{
		# Prime the time hash.
		$CurrentTime{'year'}	= $cgi->param('year');
		$CurrentTime{'month'}	= $cgi->param('month');
		$CurrentTime{'date'}	= $cgi->param('date');
		($CurrentTime{'hour'}, $CurrentTime{'minute'}, $CurrentTime{'second'}) = split(/:/, $cgi->param('time'));

		# Try to set the timezone...
		if (0 == ($Status = $TimeData->SetTimeZone($cgi->param('zone'))))
		{
			# Set the time...
			$Status = $TimeData->SetTime(\%CurrentTime);
		}
	}
	elsif ($cgi->param('applyb'))
	{
		# Try to set the time...
		if ((0 == ($Status = $TimeData->SetTimeZone($cgi->param('ntptz')))) &&
			(0 == ($Status = $TimeData->SetNTPServers([ $cgi->param('ntpserver') ]))))
		{
			# If the service is running...
			if (1 == $TimeData->GetStatusNTP())
			{
				# Restart the service.
				$TimeData->ControlNTP(2);
			}
		}
	}

	print($cgi->header());
	print($Status);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);

