#!/usr/bin/perl -w

###############################################################################
#                                                                             #
# Filename: cp_ecomm.cgi                                                      #
#                                                                             #
# Description: Contains CGI script needed to enable group operations for      #
#              e-Commerce service control on element nodes.                   #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

use strict;
use Safe;
use CGI;
# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';
use IS4Control;

###############################################################################
# ModifyState
###############################################################################

sub ModifyState
{
    my ($Function, $Service) = @_;

    # Change the state of the daemon...
    Safe::system("/etc/rc.d/init.d/$Service", "$Function");
    return 0;
}

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi) = @_;
	my $Status = 0;

	SWITCH :
	{
		# Control the services...
		if ($cgi->param('controlb_start'   )) 
        { 
            ModifyState('start_service', 'intershop4'); 
            my @status = `/bin/ps auwx`;
            $Status = (IS4Control->checkIS4App(@status)) ? 0 : 1;
            last SWITCH; 
        }
		if ($cgi->param('controlb_stop'    )) 
        { 
            ModifyState('stop_service', 'intershop4'); 
            my @status = `/bin/ps auwx`;
            (IS4Control->checkIS4App(@status)) ? 1 : 0;
            last SWITCH; 
        }
		if ($cgi->param('controlb_restart' )) 
        { 
            ModifyState('stop_service', 'intershop4');
            sleep 2;
            ModifyState('start_service', 'intershop4');
            sleep 2;
            my @status = `/bin/ps auwx`;
            (IS4Control->checkIS4App(@status)) ? 0 : 1;
            last SWITCH;
        }


		if ($cgi->param('controla_start'   ))
        { 
            ModifyState('start_db', 'intershop4');
            my @status = `/bin/ps auwx`;
            (IS4Control->checkIS4Db(@status)) ? 0 : 1;
            last SWITCH; 
        }
		if ($cgi->param('controla_stop'    )) 
        { 
            ModifyState('stop_db', 'intershop4');
            my @status = `/bin/ps auwx`;
            (IS4Control->checkIS4Db(@status)) ? 1 : 0;
            last SWITCH; 
        }
		if ($cgi->param('controla_restart' )) 
        { 
            ModifyState('stop_db', 'intershop4');
            ModifyState('start_db', 'intershop4');
            my @status = `/bin/ps auwx`;
            (IS4Control->checkIS4Db(@status)) ? 0 : 1;
            last SWITCH; 
        }


		if ($cgi->param('control_start'   )) 
        { 
            ModifyState('start_httpd', 'intershop4'); 
            my @status = `/bin/ps auwx`;
            $Status = (IS4Control->checkIS4Httpd(@status)) ? 0 : 1;
            last SWITCH; 
        }
		if ($cgi->param('control_stop'    )) 
        { 
            ModifyState('stop_httpd', 'intershop4');
            my @status = `/bin/ps auwx`;
            $Status = (IS4Control->checkIS4Httpd(@status)) ? 1 : 0;
            last SWITCH; 
        }
		if ($cgi->param('control_restart' )) 
        { 
            ModifyState('stop_httpd', 'intershop4');
            ModifyState('start_httpd', 'intershop4');
            my @status = `/bin/ps auwx`;
            $Status = (IS4Control->checkIS4Httpd(@status)) ? 0 : 1;
            last SWITCH;
        }
		
        $Status = 1;
	}
	
	print($cgi->header());
	print($Status);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
