#!/usr/bin/perl -w

###############################################################################
#                                                                             #
# Filename: cp_http.cgi                                                       #
#                                                                             #
# Description: Contains CGI script needed to enable group operations for      #
#              HTTP service control on element nodes.                         #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use MonSettings;
use Daemon;
use CGI;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)		= @_;
	my $HTTPDaemon	= new Daemon('httpd');
	my $HTTPADaemon	= new Daemon('httpd-admin');
	my $Status		= 0;

	# Flush files.
	$| = 1;

	# If toggling the daemon state...
	if ((defined($cgi->param('control_start'))) ||
		(defined($cgi->param('control_stop'))))
	{
		my $Monitor = new MonSettings();
		
		# If the configuration can be opened...
		if (0 == $Monitor->open())
		{
			# Set the monitor state.
			$Monitor->setMonitorState('http', (($cgi->param('control_start')) ? 1 : 0));

			# Close the configuration.
			$Monitor->close();
		}
	}
	
	SWITCH:
	{
		# Control the services...
		if (defined($cgi->param('controla_restart')))	{ $Status = 0; last SWITCH; }
		if (defined($cgi->param('control_start')))		{ $HTTPDaemon->Control(1);  last SWITCH; }
		if (defined($cgi->param('control_stop')))		{ $HTTPDaemon->Control(0);  last SWITCH; }
		if (defined($cgi->param('control_restart')))	{ $HTTPDaemon->Control(2);  last SWITCH; }
		$Status = 1;
	}
	
	# Print the results.
	print($cgi->header( -nph => '1' ));
	print($Status);
	
	# Close the handle.
	close(STDOUT);

	# If restarting the server...
	if (defined($cgi->param('controla_restart'))) { sleep(1); $HTTPADaemon->Control(2); }
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
