#!/usr/bin/perl -w

###############################################################################
#                                                                             #
# Filename: cp_password.cgi                                                   #
#                                                                             #
# Description: Contains CGI script needed to enable password modification on  #
#              element nodes.                                                 #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use CGI;
use Password;

###############################################################################
# ConfirmUserRights
###############################################################################

sub ConfirmUserRights
{
	my ($cgi)		= @_;
	my $UserName;
	my $CheckGID;

	$UserName	= $cgi->remote_user;
    $CheckGID	= ((10000 == (getpwnam($UserName))[3]) ||
				   (10001 == (getpwnam($UserName))[3])) ? 'yes' : 'no';

	return ($UserName, $CheckGID);
}

###############################################################################
# ChangePassword
###############################################################################

sub ChangePassword 
{
	my ($cgi, $UserName, $CheckGID) = @_;
	my $UserPasswordNew				= $cgi->param('user_password_n');
	my $UserPasswordDup				= $cgi->param('user_password_d');

	# Check the rights...
	if (('root' ne $UserName) &&
		($UserPasswordNew eq $UserPasswordDup) &&
		($CheckGID eq 'yes'))
	{ 
        # Try to set the password.
		return Password->changePassword($UserName, $UserPasswordNew);
	}
		
	return 1; 
}

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)	= @_;
	my $Status	= 1;

	# Check for a command.
	if ($cgi->param('apply'))
	{
		my ($UserName, $CheckGID) = ConfirmUserRights($cgi);

		# Try to change the password.
		$Status = ChangePassword($cgi, $cgi->param('user_name'), $CheckGID);
	}
	
	print($cgi->header());
	print($Status);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
