#!/usr/bin/perl -w

###############################################################################
#                                                                             #
# Filename: cp_power.cgi                                                      #
#                                                                             #
# Description: Contains CGI script needed to enable group operations for      #
#              power management of element nodes.                             #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use LanguageLogCGI;
use Safe;
use CGI;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi)	= @_;
	my $Log		= new LanguageLogCGI('/usr/ins/intel/gui/logs/server.log', '/usr/ins/intel/gui/locale', [ 'go_power.lrc' ]);
	
	# Return a header.
	print($cgi->header());
	
	# Enact the request.
	if ($cgi->param('control_reboot'))
	{	
		# Log the event.
		$Log->Append('security', 'information', 130002, [ $cgi->remote_user() ]);

		print(0);
		
		Safe::system('/sbin/shutdown', '-r', '0');
	}
	elsif ($cgi->param('control_shutdown')) 
	{
		# Log the event.
		$Log->Append('security', 'information', 130003, [ $cgi->remote_user() ]);

		print(0);
		
		Safe::system('/sbin/shutdown', '-h', '0');
	}
	else
	{
		print(1);
	}
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
