#!/usr/bin/perl
$VERSION = "0.5";

###############################################################################
#                                                                             #
# Filename: server_dns_edit_mailserver.cgi                                    #
#                                                                             #
# Description: Manages MX records (for domain mail servers) for a zone on     #
#              this appliance.                                                #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

use lib '/usr/ins/intel/gui/perllib';
use strict;
use CGI;
use DisplayMain;
use LanguageResource;
use IO::File;
use DNSConfig;
use DNSZone;

########################################
my $Result;
my $Feedback;

my $PreferredLanguage		= (split(/,/, $ENV{'HTTP_ACCEPT_LANGUAGE'}))[0];
my $StringResource		= new LanguageResource($PreferredLanguage, '/usr/ins/intel/gui/locale', [ 'server_dns.lrc', 'common.lrc' ]);

my %_R = (	'IDT:8500'			=> '',
		'IDQH:8500'			=> '',
		'DNS'				=> '',
		'ZONE'				=> '',
		
		'ADD'				=> '',
		'DELETE'			=> '',
		'SWAP'				=> '',
		'SORT'				=> '',

		'DNSZONENAME'			=> '',
		'MAILSERVERRECS'		=> '',
		'DOMAIN'			=> '',
		'PRIORITY'			=> '',
		'MAILSERVERADDR'		=> '',
		'DEFAULTFORDOMAINPAREN'		=> '',

		'PLEASESELECTTWORECORDSMSG'	=> '',
		'ALLSELECTEDRECORDSMSG'		=> '',
		'NOSELECTEDRECORDSMSG'		=> '',
		
		'DEFAULT_MESSAGE'		=> '');


$StringResource->GetStrings(\%_R);

########################################

########################################

my $PAGE = <<HEREMAILSERVER;
<script>
function checkall(count,type)
{
	if(eval(\"document.DNS.delall_\" + type + \".checked\") == true)
	{
		for(var i=0;i<count;i++)
			eval(\"document.DNS.\" + type + "" + i + \".checked='checked';\");
	}
	else
	{
		for(var i=0;i<count;i++)
			eval(\"document.DNS.\" + type + "" + i + \".checked='';\");
	}
}
function checkswap(count,type)
{
	var boxcount=0;
	for(var i=0;i<count;i++)	
	{
		if (eval(\"document.DNS.\" + type + "" + i + \".checked\"))
		{
			boxcount++;
		}
	}
	
	if (2 == boxcount)
	{
		return true;
	}
	else
	{
		alert("$_R{'PLEASESELECTTWORECORDSMSG'}");
		return false;
	}
}

function preparetodeleterecords(count,type)
{
	var boxcount=0;
	for(var i=0;i<count;i++)	
	{
		if (eval(\"document.DNS.\" + type + "" + i + \".checked\"))
		{
			boxcount++;
		}
	}
	
	if (0 < boxcount)
	{
		return confirm("$_R{'ALLSELECTEDRECORDSMSG'}");
	}
	else
	{
		alert("$_R{'NOSELECTEDRECORDSMSG'}");
		return false;
	}
}

</script>
<FORM METHOD="POST" NAME=DNS ACTION="server_dns_edit_mailserver.cgi" ENCTYPE="application/x-www-form-urlencoded">
<INPUT TYPE="hidden" NAME="zname" VALUE="DOMAINNAME">

<TABLE BORDER="0" WIDTH="375" BGCOLOR="#eeeeee">
  <TR>
    <TD>
      <TABLE BORDER="0" WIDTH="100%">
        <TR>
          <TD WIDTH="100%" colspan="2">&nbsp;
          </TD>
        </TR>
        <tr>
          <TD WIDTH="50%" NOWRAP><b>$_R{'DNSZONENAME'}:</b>
          </TD>
          <TD WIDTH="50%" NOWRAP>DOMAINNAME
          </TD>
        </tr>
        <tr>
          <td width="100%" align="left" valign="bottom" colspan="2"><b>$_R{'MAILSERVERRECS'}</b>
          </td>
        </tr>
        <tr>
          <td width="100%" align="left" valign="bottom" colspan="2"><input type="button" class="clsButton" value="$_R{'ADD'}" name="B16" onclick="javascript:location='server_dns_addrecord_MX.cgi?zname=DOMAINNAME'">
            <input type="submit" class="clsButton" value="$_R{'DELETE'}" name="DeleteRec" onclick=" return preparetodeleterecords(RECNUM,'rec');">
            <input type="submit" class="clsButton" value="$_R{'SWAP'}" name="SwapRec" onclick=" return checkswap(RECNUM,'rec');">
          </td>
        </tr>
        <tr>
          <td width="100%" align="left" valign="bottom" colspan="2">&nbsp;</td>
        </tr>
        <TR>
          <TD WIDTH="100%" colspan="2">
            <table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="#EEEEEE">
              <tr>
                <td width="100%">
                  <table border="1" cellpadding="2" cellspacing="0" width="100%" bgcolor="#FFFFFF" bordercolor="#EEEEEE">
                    <tr>
                      <td width="2%" bgcolor="#808080"><input type="checkbox" name="delall_rec" value="delall_rec" onclick="javascript:checkall(RECNUM,'rec');">&nbsp;
                      </td>
                      <td width="40%" nowrap bgcolor="#808080"><b><font color="#FFFFFF">$_R{'DOMAIN'}</font></b>
                      </td>
                      <td width="18%" nowrap bgcolor="#808080"><b><font color="#FFFFFF">$_R{'PRIORITY'}</font></b>
                      </td>
                      <td width="40%" nowrap bgcolor="#808080"><b><font color="#FFFFFF">$_R{'MAILSERVERADDR'}</font></b>
                      </td>
                    </tr>
RECORDSDATA
                  </table>
                </td>
              </tr>
            </table>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>          

</FORM>
HEREMAILSERVER


###############################################################################
# SetPage
###############################################################################

sub SetPage
{
	my ($html, $Records, $Domainname, $recordcount) = @_;
	
	# Set the DNS Records.
	$html =~ s/RECORDSDATA/$Records/s;

	# Set the DNS Records.
	$html =~ s/DOMAINNAME/$Domainname/g;

	# Set the DNS Records.
	$html =~ s/RECNUM/$recordcount/g;

	return $html;
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi					= new CGI;
my $html				= $PAGE;
my $Records;
my $SubzoneRecords;
my $Domainname;
my $NumZones;
my ($ia,$ib,$ic,$id);
my $i;
my $j;
my $count;
my $total;
my (@pz_soa,@pz_ns,@pz_mx,@pz_a,@pz_cname,@pz_ptr,@pz_nssub);

if ($cgi->param('DeleteRec'))
{
	my $zonename = $cgi->param('zname');        
	my $fname = $cgi->param('zonefilename');

	my $realdomname = $zonename.'.';
	
	my @collect_from;
	my $collect_count = 0;

	my $delete_count = 0;

	# Iterate through data structure and display meaningful information.
	for ($i = 0; $i < $cgi->param('recordcount'); $i++)
	{
		# if the item is checked
		if($cgi->param("rec$i"))
		{	
			my $retype = $cgi->param("rectype$i");
			my $refrom = $cgi->param("recfrom$i");
			my $reto = $cgi->param("recto$i");
			my $repri = $cgi->param("recpri$i");
			
			# Add $refrom to list, if it doesn't already exist.

			my $j;
			my $collect_exists = 0;
			for ($j = 0; $j < $collect_count; $j++)
			{
				if ( $collect_from[$j] eq $refrom )
				{
					$collect_exists = 1;
				}
			}

			if ($collect_exists eq 0)
			{
				$collect_from[$collect_count] = $refrom;
				$collect_count++;
			}
			
			$ia = DNSZone->zone_delrecord($zonename,$fname,$retype,$refrom,$reto,$repri); 
			$ib += $ia;

			if ($ia eq 0)
			{
				$delete_count++;
			}
		}
	}	

	if ($ib ne 0)
	{
		$Result = 850007;
		$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
		goto DISPLAYMAINFORM;
	}

	if ($delete_count ne 0)
	{
		# Begin wacky SORT function here.
		# First, step the "from" names we collect in @collect_from

		$ia = DNSZone->zone_getinfo($zonename,$fname,\@pz_soa,\@pz_ns,\@pz_mx,\@pz_a,\@pz_cname,\@pz_ptr,\@pz_nssub);

		if ($ia ne 0)
		{
			$Result = 850005;
			$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
		}

		# Get all zone information about current records (excluding latest deleted records) here.
		# Use @pz_mx as our data source.

		my $mxcount = scalar(@pz_mx);

		my $partial_fail = 0;

		my $j;
		for ($j = 0; $j < $collect_count; $j++)
		{
			# For each element in array @collect_from,
			# Pick the MX elements which match that value.
			
			my @a1;
			my $t1;
			my $acount = 0;
			
			# t1 now contains the string for the domain (host) we wish to sort upon
			$t1 = $collect_from[$j];
			
			my $k;
			for ($k = 0; $k < $mxcount; $k++)
			{
				# Count through entire MX array, and pick only those entries that match for [$k][0] == t1
				
				if ($pz_mx[$k][0] eq $t1)
				{
					# If so, then copy the array contents
					$a1[$acount][0] = $pz_mx[$k][0];
					$a1[$acount][1] = $pz_mx[$k][1];
					$a1[$acount][2] = $pz_mx[$k][2];
					$acount++;
				}
			}
			
			# By this time, there are now $acount number of arrays inside @a1.  Each array's [0] should
			# match $t1.  Next step is to sort @a1 based on priority (ascending, custom sort).
			
			@a1 = sort { $$a[2] <=> $$b[2] } @a1;
			
			# Now that this is done, the first element has the lowest pri value, the second has the
			# second lowest, etc.  It is now safe to re-assign arbitrary priority values, such that the
			# relative order is maintained.  Put these new values in [3] of each @a1 element.
			
			$acount = scalar(@a1);

			for ($k = 0; $k < $acount; $k++)
			{
				# Go by ascending multiples of 10.  That seems to be easy.
				# (At least for those of us who use the decimal system.)
				
				$a1[$k][3] = (($k + 1) * 10 );
			}
			
			# Now, for each element of @a1, [2] contains the old pri value, and [3] contains the new one.
			# Issue a call for each element to update with the new values.
			
			my $replcount = 0;

			for ($k = 0; $k < $acount; $k++)
			{
				# Call the zone_replrecord function.
				
				$ib = DNSZone->zone_replrecord(	$zonename,$fname,'MX',
								$a1[$k][0],$a1[$k][1],$a1[$k][2],
								$a1[$k][0],$a1[$k][1],$a1[$k][3] );
				if ($ib eq 0)
				{
					$replcount++;
				}
			}
			
			# Now, reconcile the values of what we expected to replace, and what actually got
			# a successful replacement.
					
			if ($replcount ne $acount)
			{
				# Partial or utter failure
				$partial_fail++;
			}

		}		# END FOR loop.

		# Check value in $partial_fail to see if it's not zero.
		
		if ($partial_fail eq 0)
		{
			$Result = 0;
			$Feedback = '<b><font color="green">' . $StringResource->_S('850006') . '</font></b>';
		}
		else
		{
			$Result = 850004;
			$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
		}
		


		# Now, after our convoluted little replacement scheme above, let's increment the zone
		# and force BIND to do an update based on the new data file.

		DNSZone->zone_increment($zonename,$fname);
	}

	goto DISPLAYMAINFORM;


}


if ($cgi->param('SwapRec'))
{
	my $zonename = $cgi->param('zname');        

	my $fname = $cgi->param('zonefilename');
	
	my $recordcount = $cgi->param('recordcount');
	my $swapcount = 0;
	my $rec_a;
	my $rec_b;
	my ($i,$j);
	
	for ($i = 0; $i < $recordcount; $i++)
	{
		if ($cgi->param("rec$i"))
		{
			if ($swapcount eq 0)
			{
				$rec_a = $i;
			}
			else
			{
				$rec_b = $i;
			}
			$swapcount++;
		}
	}
	
	if ($swapcount ne 2)
	{
		$Result = 850003;
		$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
	}
	else
	{
		# Now, $rec_a and $rec_b contain the two IDs pointing to MX records to be swapped.
		
		my $swap_a = $cgi->param("recpri$rec_b");
		my $swap_b = $cgi->param("recpri$rec_a");

		my $rec_afrom = $cgi->param("recfrom$rec_a");
		my $rec_ato = $cgi->param("recto$rec_a");
		my $rec_apri = $cgi->param("recpri$rec_a");

		my $rec_bfrom = $cgi->param("recfrom$rec_b");
		my $rec_bto = $cgi->param("recto$rec_b");
		my $rec_bpri = $cgi->param("recpri$rec_b");

		my ($ia,$ib,$ic);

		$ia = DNSZone->zone_replrecord($zonename,$fname,"MX",$rec_afrom,$rec_ato,$rec_apri,$rec_afrom,$rec_ato,$swap_a);

		if ($ia eq 0)
		{
			$ib = DNSZone->zone_replrecord($zonename,$fname,"MX",$rec_bfrom,$rec_bto,$rec_bpri,$rec_bfrom,$rec_bto,$swap_b);

			if ($ib eq 0)
			{
				$Result = 0;
				$Feedback = '<b><font color="green">' . $StringResource->_S('850008') . '</font></b>';
			}

			else
			{
				# If the second one failed, then put the first one back.
				$ic = DNSZone->zone_replrecord($zonename,$fname,"MX",$rec_afrom,$rec_ato,$swap_a,$rec_afrom,$rec_ato,$rec_apri);

				$Result = 850002;
				$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
			}

			DNSZone->zone_increment($zonename,$fname);
		}

		else
		{
			$Result = 850002;
			$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
		}

	}

}

DISPLAYMAINFORM:

my $zonename = $cgi->param('zname');        

if ($cgi->param('newrecordmessage'))
{
	$Result .= 0;
	$Feedback = '<b><font color="green">' . $StringResource->_S('850009') . '</font></b>';
	DNSConfig->named_update('named');
}

my @zone_dat_list;

$ia = DNSConfig->zone_list(\@zone_dat_list);
$NumZones = scalar(@zone_dat_list);

# Iterate through data structure and display meaningful information.
for ($i = 0; $i < $NumZones; $i++)
{
	# for each zone print out the records
	if($zone_dat_list[$i][0] eq $zonename)
	{
		$ib = DNSZone->zone_getinfo($zonename,$zone_dat_list[$i][1],\@pz_soa,\@pz_ns,\@pz_mx,\@pz_a,\@pz_cname,\@pz_ptr,\@pz_nssub);
		
		if ($ib ne 0)
		{
			$Result = 850010;
			$Feedback = '<b><font color="red">' . $StringResource->_S($Result) . '</font></b>';
			goto OUTPAGE;
		}
		
		# Iterate through the data structure getting the MX records
		$count = scalar(@pz_mx);
		
		# Sort MX Records by increasing priority values.
		
		@pz_mx = sort
		{	### $$a[2] <=> $$b[2]
			# Begin custom sort function.
			# First, sort by the source field [0]
			# After that, sort by priority field [2]
			
			my ($aa1,$aa2,$bb1,$bb2);
			my $res1;

			$aa1 = $$a[0];
			$aa2 = $$a[2];
			$bb1 = $$b[0];
			$bb2 = $$b[2];
			
			$res1 = ($aa1 cmp $bb1);
			
			if ($res1 eq 0)
			{
				return ($aa2 <=> $bb2);
			}
			else
			{
				return $res1;
			}

		} @pz_mx;

		for ($j = 0; $j < $count; $j++)
		{
			my $num = $total + $j;
			my $thisdomain;
			if($pz_mx[$j][0] eq '@')
			{
				$thisdomain = $_R{'DEFAULTFORDOMAINPAREN'} . "&nbsp\;";
			}
			else
			{
				$thisdomain = $pz_mx[$j][0];
			}

			my $perc = '%';

			$Records .= "<tr><td width=2$perc><input type=checkbox name=rec$num value=ON><input type=hidden name=rectype$num value=MX><input type=hidden name=recfrom$num value=$pz_mx[$j][0]><input type=hidden name=recto$num value=$pz_mx[$j][1]><input type=hidden name=recpri$num value=$pz_mx[$j][2]></td>";
			$Records .= "<td width=49$perc nowrap>$thisdomain</td>";
			$Records .= "<td width=25$perc nowrap>$pz_mx[$j][2]</td>";
			$Records .= "<td width=24$perc nowrap>$pz_mx[$j][1]</td></tr>\n";
		}

		$total += $count;

		$Records .= "<input type=hidden name=zonefilename value=$zone_dat_list[$i][1]>";

		goto DISPLAYREALFORM;  # Break out of the loop since we found the domain

	}
}

DISPLAYREALFORM:

$Records .= "<input type=hidden name=recordcount value=$total>\n";

OUTPAGE:

$html = SetPage($PAGE, $Records, $zonename, $total);

my %var;
$var{'q'}			= $cgi;
$var{'html'}			= $html;
$var{'class'}			= 'server_dns';
$var{'id'}			= 8500;
$var{'title'}			= $_R{'IDT:8500'};
$var{'root-link'}		= 'server_dns';
$var{'result'}			= $Result;
$var{'feedback'}		= $Feedback;
$var{'cookiecrumbs'} =	[	{name=>$StringResource->_S('IDT:8000'), location=>"server_dns.cgi"},
				{name=>$StringResource->_S('IDT:8300'), location=>"server_dns_edit.cgi?zname=$zonename"},
			];

DisplayMain->printDocument(\%var);

exit(0);

