#!/usr/bin/perl

###############################################################################
#                                                                             #
# Filename: server_navbar.cgi                                                 #
#                                                                             #
# Description: Contains CGI script needed to render the server administrator  #
#              navigation bar.                                                #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use LanguageResource;
use CGI;
use ProductInformation;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi) 				= @_;
	my $PreferredLanguage	= (split(/,/, $ENV{'HTTP_ACCEPT_LANGUAGE'}))[0];
	my $ImageResource		= new LanguageResource($PreferredLanguage, '/usr/ins/intel/gui/locale/images');
	my $ImgPathNavBar		= $ImageResource->ResolveResourceFile('navbar-server.jpg');
	my $BodyTag;
	my $html;
	my $ProductInformation = new ProductInformation();
	
		
	# Safe defaults.
	$ImgPathNavBar	= '' unless(defined($ImgPathNavBar));

	# Get just the hidden part of the file name.
	$ImgPathNavBar	=~ s/^\/usr\/ins\/intel\/gui(\/locale\/images\/.*)$/$1/;
	
	# Based on the user agent...
	if (-1 < (index($cgi->user_agent(), 'MSIE')))
	{ 
		# Use a MSIE compatible body tag.
		$BodyTag = "<body bgcolor=#ffffff background=$ImgPathNavBar onload=check_selected_item() leftmargin=0 topmargin=0>"; 
	}
	else
	{ 
		# Use a Netscape compatible body tag.
		$BodyTag = "<body bgcolor=#ffffff onResize=location.reload() onload=check_selected_item() background=$ImgPathNavBar leftmargin=0 topmargin=0>"; 
	}

	$html = <<HERE;
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel=stylesheet href=/style/style.css type=text/css>
</head>
<script language=javascript>
var selected_item = "server_status";

function check_selected_item()
{
	if(parent.main.selected_item)
	{
		if(parent.main.selected_item != selected_item)
			selectitem(parent.main.selected_item);
	}
}
 
function selectitem(itemname)
{
	eval("document.images."+ selected_item +".src = '/images/blank.gif';");
	eval("document.images."+ itemname +".src = '/images/server_selected.gif';");
	selected_item = itemname;
}

function changeImages(itemname)
{
	if (itemname != selected_item)
	{
		var picvalue = eval("document.images."+ itemname +".src");
	
		if (picvalue.indexOf('blank.gif') != -1)
		{
			eval("document.images."+ itemname +".src = '/images/server_selection.gif';");
		}
		else
		{
			eval("document.images."+ itemname +".src = '/images/blank.gif';");
		}
	}
}
</script>
$BodyTag
	<table border=0 cellpadding=0 cellspacing=0>
	<tr>
		<td colspan=3><IMG SRC=/images/blank.gif width=158 height=22></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_status.cgi target=main onmouseover="changeImages('server_status');" onmouseout="changeImages('server_status');" onclick="selectitem('server_status');">
			<img src=/images/server_selected.gif width=131 height=14 border=0 id=server_status name=server_status></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_domains.cgi target=main onmouseover="changeImages('server_domains');" onmouseout="changeImages('server_domains');" onclick="selectitem('server_domains');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_domains name=server_domains></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_users.cgi target=main onmouseover="changeImages('server_users');" onmouseout="changeImages('server_users');" onclick="selectitem('server_users');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_users name=server_users></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_updates.cgi target=main onmouseover="changeImages('server_updates');" onmouseout="changeImages('server_updates');" onclick="selectitem('server_updates');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_updates name=server_updates></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_power.cgi target=main onmouseover="changeImages('server_power');" onmouseout="changeImages('server_power');" onclick="selectitem('server_power');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_power name=server_power></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_backup.cgi target=main onmouseover="changeImages('server_backup');" onmouseout="changeImages('server_backup');" onclick="selectitem('server_backup');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_backup name=server_backup></a></td>
	</tr>
	<tr>
		<td colspan=3><img src=/images/blank.gif width=131 height=18></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_http.cgi target=main onmouseover="changeImages('server_http');" onmouseout="changeImages('server_http');" onclick="selectitem('server_http');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_http name=server_http></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_mail.cgi target=main onmouseover="changeImages('server_mail');" onmouseout="changeImages('server_mail');" onclick="selectitem('server_mail');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_mail name=server_mail></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_ftp.cgi target=main onmouseover="changeImages('server_ftp');" onmouseout="changeImages('server_ftp');" onclick="selectitem('server_ftp');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_ftp name=server_ftp></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_telnet.cgi target=main onmouseover="changeImages('server_telnet');" onmouseout="changeImages('server_telnet');" onclick="selectitem('server_telnet');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_telnet name=server_telnet></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_snmp.cgi target=main onmouseover="changeImages('server_snmp');" onmouseout="changeImages('server_snmp');" onclick="selectitem('server_snmp');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_snmp name=server_snmp></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_dns.cgi target=main onmouseover="changeImages('server_dns');" onmouseout="changeImages('server_dns');" onclick="selectitem('server_dns');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_dns name=server_dns></a></td>
	</tr>
HERE
	
	# Look for a storefront configuration...
	if (2 == $ProductInformation->getClassification())
	{
		$html .= <<HERE;
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_ecomm.cgi TARGET=main onmouseover="changeImages('server_ecomm');" onmouseout="changeImages('server_ecomm');" onclick="selectitem('server_ecomm');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_ecomm name=server_ecomm></a></td>
	</tr>
HERE
	}

$html .= <<HERE;		
	<tr>
		<td colspan=3><img src=/images/blank.gif width=131 height=24></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_system_logs.cgi target=main onmouseover="changeImages('server_system_logs');" onmouseout="changeImages('server_system_logs');" onclick="selectitem('server_system_logs');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_system_logs name=server_system_logs></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_system_usage.cgi target=main onmouseover="changeImages('server_system_usage');" onmouseout="changeImages('server_system_usage');" onclick="selectitem('server_system_usage');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_system_usage name=server_system_usage></a></td>
	</tr>
	<tr>
		<td colspan=3><img src=/images/blank.gif width=131 height=24></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_network.cgi target=main onmouseover="changeImages('server_network');" onmouseout="changeImages('server_network');" onclick="selectitem('server_network');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_network name=server_network></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_date.cgi target=main onmouseover="changeImages('server_date');" onmouseout="changeImages('server_date');" onclick="selectitem('server_date');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_date name=server_date></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_frontpanel.cgi target=main onmouseover="changeImages('server_frontpanel');" onmouseout="changeImages('server_frontpanel');" onclick="selectitem('server_frontpanel');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_frontpanel name=server_frontpanel></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=server_alerts.cgi target=main onmouseover="changeImages('server_alerts');" onmouseout="changeImages('server_alerts');" onclick="selectitem('server_alerts');">
			<img src=/images/blank.gif width=131 height=13 border=0 id=server_alerts name=server_alerts></a></td>
	</tr>
	<tr>
		<td colspan=3><img src=/images/blank.gif width=131 height=22></td>
	</tr>
	</table>
</body>
</html>
HERE

	# Send pack the page.
	print($cgi->header(-expires=>'Mon, 21-May-1971 00:00:00 GMT'));
	print($html);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
