#!/usr/bin/perl

###############################################################################
#                                                                             #
# Filename: user_navbar.cgi                                                   #
#                                                                             #
# Description: Contains CGI script needed to render the user navigation bar.  #
#                                                                             #
###############################################################################
###############################################################################
#                                                                             #
#  Copyright  2000 - 2001 Intel Corporation.                                 #
#  Intel Corporation All Rights Reserved.                                     #
#                                                                             #
#  The source code contained or described herein and all documents related to #
#  the source code ("Material") are owned by Intel Corporation or its         #
#  suppliers or licensors.  Title to the Material remains with Intel          #
#  Corporation or its suppliers and licensors.  The Material contains trade   #
#  secrets and proprietary and confidential information of Intel or its       #
#  suppliers and licensors.  The Material is protected by worldwide copyright #
#  and trade secret laws and treaty provisions.  No part of the Material may  #
#  be used, copied, reproduced, modified, published, uploaded, posted,        #
#  transmitted, distributed, or disclosed in any way without Intel's prior    #
#  express written permission.                                                #
#                                                                             #
#  No license under any patent, copyright, trade secret or other intellectual #
#  property right is granted to or conferred upon you by disclosure or        #
#  delivery of the Materials, either expressly, by implication, inducement,   #
#  estoppel or otherwise. Any license under such intellectual property rights #
#  must be express and approved by Intel in writing.                          #
#                                                                             #
###############################################################################

# Put the PERL library in the path.
use lib '/usr/ins/intel/gui/perllib';

use strict;
use LanguageResource;
use CGI;

###############################################################################
# Main
###############################################################################

sub Main
{
	my ($cgi) 				= @_;
	my $PreferredLanguage	= (split(/,/, $ENV{'HTTP_ACCEPT_LANGUAGE'}))[0];
	my $ImageResource		= new LanguageResource($PreferredLanguage, '/usr/ins/intel/gui/locale/images');
	my $ImgPathNavBar		= $ImageResource->ResolveResourceFile('navbar-user.jpg');
	my $BodyTag;
	my $html;
	
	# Safe defaults.
	$ImgPathNavBar	= '' unless(defined($ImgPathNavBar));

	# Get just the hidden part of the file name.
	$ImgPathNavBar	=~ s/^\/usr\/ins\/intel\/gui(\/locale\/images\/.*)$/$1/;
	
	# Based on the user agent...
	if (-1 < (index($cgi->user_agent(), 'MSIE')))
	{ 
		# Use a MSIE compatible body tag.
		$BodyTag = "<body bgcolor=#ffffff background=$ImgPathNavBar onload=check_selected_item() leftmargin=0 topmargin=0>"; 
	}
	else
	{ 
		# Use a Netscape compatible body tag.
		$BodyTag = "<body bgcolor=#ffffff onResize=location.reload() onload=check_selected_item() background=$ImgPathNavBar leftmargin=0 topmargin=0>"; 
	}

	$html = <<HERE;
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel=stylesheet href=/style/style.css type=text/css>
</head>
<script language=javascript>
var selected_item = "user_status";

function check_selected_item()
{
	if(parent.main.selected_item)
	{
		if(parent.main.selected_item != selected_item)
			selectitem(parent.main.selected_item);
	}
}

function selectitem(itemname)
{
	eval("document.images."+ selected_item +".src = '/images/blank.gif';");
	eval("document.images."+ itemname +".src = '/images/user_selected.gif';");
	selected_item = itemname;
}

function changeImages(itemname)
{
	if (itemname != selected_item)
	{
		var picvalue = eval("document.images."+ itemname +".src");
	
		if (picvalue.indexOf('blank.gif') != -1)
		{
			eval("document.images."+ itemname +".src = '/images/user_selection.gif';");
		}
		else
		{
			eval("document.images."+ itemname +".src = '/images/blank.gif';");
		}
	}
}
</script>
$BodyTag
	<table border=0 cellpadding=0 cellspacing=0>
	<tr>
		<td colspan=3><IMG SRC=/images/blank.gif width=158 height=14></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=user_status.cgi target=main onmouseover="changeImages('user_status');" onmouseout="changeImages('user_status');" onclick="selectitem('user_status');">
			<img src=/images/user_selected.gif width=131 height=15 border=0 id=user_status name=user_status></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=user_passwd.cgi target=main onmouseover="changeImages('user_passwd');" onmouseout="changeImages('user_passwd');" onclick="selectitem('user_passwd');">
			<img src=/images/blank.gif width=131 height=15 border=0 id=user_passwd name=user_passwd></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=user_setmail.cgi target=main onmouseover="changeImages('user_setmail');" onmouseout="changeImages('user_setmail');" onclick="selectitem('user_setmail');">
			<img src=/images/blank.gif width=131 height=15 border=0 id=user_setmail name=user_setmail></a></td>
	</tr>
	<tr>
		<td width=3></td>
		<td width=138>
			<a href=user_diskuse.cgi target=main onmouseover="changeImages('user_diskuse');" onmouseout="changeImages('user_diskuse');" onclick="selectitem('user_diskuse');">
			<img src=/images/blank.gif width=131 height=15 border=0 id=user_diskuse name=user_diskuse></a></td>
	</tr>
	<tr>
		<td colspan=3><img src=/images/blank.gif width=131 height=22></td>
	</tr>
	</table>
</body>
</html>
HERE

	# Send pack the page.
	print($cgi->header(-expires=>'Mon, 21-May-1971 00:00:00 GMT'));
	print($html);
}

###############################################################################
# The main body of the script.
###############################################################################

my $cgi = new CGI;

Main($cgi);
